<!DOCTYPE html>
<html>
<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    
    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.3.1/dist/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    
    <title>Akses kadipiro</title>
</head>
<body>
    
    <div class="card">
        <div class="card-body">
            <div class="input-group mb-3">
                <div class="input-group-prepend">
                    <label class="input-group-text" for="inputGroupSelectNama">Nama</label>
                </div>
                <select class="form-control" id="inputGroupSelectNama">
                </select>
            </div>

            <button type="button" class="btn btn-success" id="btnMasuk" onclick="masuk()">Masuk</button>
            <button type="button" class="btn btn-warning" id="btnKeluar" onclick="keluar()">Keluar</button>
        </div>
    </div>

    <div class="card">
        <br><br><br>
        <h3>Daftar mahasiswa di Kadipiro</h3>
        <span>Jumlah mahasiswa : <span id="countMhs"></span></span>
        <br>
        <table class="table table-striped">
            <thead>
                <tr>
                    <th scope="col">Waktu Masuk</th>
                    <th scope="col">Nama</th>
                </tr>
            </thead>
            <tbody id="currentMhs">
            </tbody>
            </table>
    </div>
    
    <! --Connecting html page to socket.io -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/4.4.1/socket.io.js"></script>
    <script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>

    <script>
        // const socket = io.connect('https://kadipiro.mbkm.stechoq.com');
        const socket = io.connect('http://localhost:3000');
        
        socket.on('info/alert', (data)=>{
            let parsed = {}
            try{
                parsed = JSON.parse(data)
            }catch(err){
                return
            }

            swal(parsed.message, {
                icon: parsed.isSuccess ? "success" : "error",
                buttons: false,
                timer: 2000,
            });
        });

        socket.on('info/listMhs', (data)=>{
            const parrentEle = document.getElementById('inputGroupSelectNama');
            let listMhs = [];

            parrentEle.innerHTML = "";
            const nodeDef = document.createElement("option");
            nodeDef.value = null
            nodeDef.innerHTML = "Choose..."
            parrentEle.appendChild(nodeDef);

            try{
                listMhs = JSON.parse(data);
                if(!listMhs.length){
                    return
                }
            }catch(err){}


            for(let mhs of listMhs){
                const node = document.createElement("option");
                node.value = mhs.id
                node.innerHTML = mhs.name
                parrentEle.appendChild(node);
            }
        });

        socket.on('info/currentMhs', (data)=>{
            const parrentEle = document.getElementById('currentMhs');
	        const countMhs = document.getElementById('countMhs');

            let listMhs = [];

            parrentEle.innerHTML = "";

            try{
                listMhs = JSON.parse(data);
                if(!listMhs.length){
                    return
                }
            }catch(err){}
            


            countMhs.innerHTML = listMhs.length;
            for(let mhs of listMhs){
                const tr = document.createElement("tr");
                
                const td1 = document.createElement("td");
                td1.innerHTML = mhs.timestampMasuk
                tr.appendChild(td1);
                
                const td2 = document.createElement("td");
                td2.innerHTML = mhs.name
                tr.appendChild(td2);

                parrentEle.appendChild(tr);
            }
        });


        function masuk(){
            const mhs = document.getElementById("inputGroupSelectNama").value;
            socket.emit("masuk", JSON.stringify({id: mhs}));
        }

        function keluar(){
            const mhs = document.getElementById("inputGroupSelectNama").value;
            socket.emit("keluar", JSON.stringify({id: mhs}));
        }

        
    </script>
    
    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.14.7/dist/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.3.1/dist/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
</body>
</html>
